<template>
    <div class="editor tags">
        <div class="tag-icon" @click="toggleSelection">
            <app-icon size="lg" icon="tags"></app-icon>
            <span class="title" v-if="simple">Tags</span>
        </div>
        <section class="choosen-tags">
            <div class="tags">
                <span v-if="choosedTags.length < 1" class="no-tags">No Tags</span>
                <transition-group name="list">
                    <span
                        class="tag"
                        @click="removeTag(tag)"
                        v-for="tag in choosedTags"
                        :key="tag.id"
                    >
                        <span class="title">{{ tag.name }}</span>
                        <span class="icon">
                            <app-icon icon="times-circle"></app-icon>
                        </span>
                    </span>
                </transition-group>
            </div>
        </section>
        <transition name="move-up">
            <section class="selection" v-if="open">
                <div class="action">
                    <app-icon @click="toggleSelection" icon="times-circle"></app-icon>
                </div>
                <ol class="list-of-tags">
                    <li
                        @click="addTag(tag)"
                        v-for="(tag, index) in allTags"
                        :key="index"
                    >{{ tag.name}}</li>
                </ol>
            </section>
        </transition>
    </div>
</template>

<style lang="css" scoped>
.move-up-enter-active,
.move-up-leave-active {
    transition: all 200ms cubic-bezier(0.4, 0, 0.2, 1);
}
.move-up-enter,
.move-up-leave-to {
    opacity: 0;
    transform: translateY(200px);
}

.list-item {
    display: inline-block;
    margin-right: 10px;
}
.list-enter-active,
.list-leave-active {
    transition: all 600ms;
}
.list-enter, .list-leave-to /* .list-leave-active below version 2.1.8 */ {
    opacity: 0;
    transform: translateY(30px);
}
</style>

<script lang='ts'>
import Vue from 'vue'
import Component from 'vue-class-component'
import { Prop } from 'vue-property-decorator'
import { State } from 'vuex-class'
import { ITag } from '@/store/types/tags'
import { IRoot } from '@/store/types/root'

@Component
export default class NoteTagsForFilter extends Vue {
    // Props

    @Prop({ default: true }) simple: boolean | undefined

    // Data

    open: boolean = false
    choosedTags: ITag[] = []

    // State

    @State((state: IRoot) => {
        return state.Tags.tags
    })
    allTags: ITag[] | undefined

    // Methods

    toggleSelection() {
        this.open = !this.open
    }

    doesTagExist(tag: ITag): boolean {
        const tagFound = this.choosedTags.filter(_tag => _tag.id === tag.id)

        if (tagFound.length > 0) {
            return true
        } else {
            return false
        }
    }

    addTag(tag: ITag) {
        if (!this.doesTagExist(tag)) {
            this.choosedTags.push(tag)
            this.$emit('choosenTags', this.choosedTags)
        }
        this.toggleSelection()
    }

    removeTag(tag: ITag) {
        if (this.doesTagExist(tag)) {
            const index = this.choosedTags.findIndex(_tag => _tag.id === tag.id)

            if (index !== -1) {
                this.choosedTags.splice(index, 1)
                this.$emit('choosenTags', this.choosedTags)
            }
        }
    }
}
</script>